/** Abstract class for sorting algorithms on collection 
 */

import java.util.Comparator;

abstract class AAlgorithms {

    /* The subclasses of this class will have a field dataset which
     * contains the collection to be sorted in the appropriate format
     * that the Algorithms class is specialized for.
     */

    /** add an object to the dataset
     * If the dataset was previously sorted, it may no longer be. */
    abstract void add(Object o);
    
    /** insertion sort algorithm
     * Sorts the dataset using the given comparator to do comparisons */
    abstract void insertionSort(Comparator c);
    
    /** merge sort algorithm
     * Sorts the dataset using the given comparator to do the comparisons */
    abstract void mergeSort(Comparator c);
}
